package org.devcake.groovy.remoteconsole.ui

import groovy.ui.Console

import org.devcake.groovy.remoteconsole.RemoteConsoleClient
import org.codehaus.groovy.runtime.InvokerHelper
import org.devcake.groovy.autoimports.ConsoleUtils

/**
 * Created by IntelliJ IDEA.
 * User: Admin
 * Date: 30.09.2010
 * Time: 3:14:33
 * To change this template use File | Settings | File Templates.
 */
class RemoteConsole extends Console {

    RemoteConsole(ClassLoader parent) {
        super(parent)
    }

    void runScript(EventObject evt) {
        runScriptImpl(inputArea.getText(), inputArea.getText())
    }

    void runSelectedScript(EventObject evt) {
        runScriptImpl(inputArea.getText(), inputArea.getSelectedText())
    }

    private void runScriptImpl(String fullScript, String selectedScript) {
        selectedScript = selectedScript ?: fullScript
        appendScriptOutput(selectedScript)
        def p = new ConsoleScriptExecutionProcessor(this)
        def client = new RemoteConsoleClient(p)
        Thread.start {
            try {
                client.execute(RemoteConsoleClient.getScriptOptions(fullScript), fullScript, selectedScript)
            } catch(e) {
                // we use InvokerHelper, because the method is private and nto accessible from the subclass
                InvokerHelper.invokeSuperMethod(this, 'reportException', e)
            }
        }
    }

    private void appendScriptOutput(String script) {
        script.eachLine {
            appendOutputNl 'groovy> ', promptStyle
            appendOutput it, commandStyle
        }
        appendOutputNl('\n', promptStyle)
    }

    static void main(args) {
        ConsoleUtils.runConsole RemoteConsole, args
    }
}
